Time::Location::Zone - Crystal 1.16.3

# struct Time::Location::Zone

- Time::Location::Zone
- Struct
- Value
- Object

##
Overview

A `Zone` represents a time zone offset in effect in a specific `Location`.

Some zones have a `#name` or abbreviation (such as `PDT`, `CEST`). For an unnamed zone the formatted offset should be used as name.

##
Defined in:

time/location.cr

##
Constant Summary

UTC = `new("UTC", 0, false)`

  This is the `UTC` time zone with offset `+00:00`.

  It is the only zone offset used in `Time::Location::UTC`.

##
Constructors

- .new(name : String | Nil, offset : Int32, dst : Bool)

  Creates a new `Zone` named name with offset from UTC in seconds.

##
Instance Method Summary

- #dst? : Bool

  Returns `true` if this zone offset is daylight savings time.

- #format(io : IO, with_colon = true, with_seconds = :auto)

  Prints `#offset` to io in the format `+HH:mm:ss`.

- #format(with_colon = true, with_seconds = :auto)

  Returns the `#offset` formatted as `+HH:mm:ss`.

- #inspect(io : IO) : Nil

  Prints this `Zone` to io.

- #name : String

  Returns the name of the zone.

- #offset : Int32

  Returns the offset from UTC in seconds.

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(name : String | Nil, offset : Int32, dst : Bool) #

Creates a new `Zone` named name with offset from UTC in seconds. The parameter dst is used to declare this zone as daylight savings time.

If `#name` is `nil`, the formatted `#offset` will be used as `#name` (see `#format`).

Raises `InvalidTimezoneOffsetError` if seconds is outside the supported value range `-86_400..86_400` seconds (`-24:00` to `+24:00`).

##
Instance Method Detail

def dst? : Bool #

Returns `true` if this zone offset is daylight savings time.

def format(io : IO, with_colon = true, with_seconds = :auto) #

Prints `#offset` to io in the format `+HH:mm:ss`. When with_colon is `false`, the format is `+HHmmss`.

When with_seconds is `false`, seconds are omitted; when `:auto`, seconds are omitted if `0`.

def format(with_colon = true, with_seconds = :auto) #

Returns the `#offset` formatted as `+HH:mm:ss`. When with_colon is `false`, the format is `+HHmmss`.

When with_seconds is `false`, seconds are omitted; when `:auto`, seconds are omitted if `0`.

def inspect(io : IO) : Nil #

Prints this `Zone` to io.

It contains the `#name`, hour-minute-second format (see `#format`), `#offset` in seconds and `"DST"` if `#dst?`, otherwise `"STD"`.

def name : String #

Returns the name of the zone.

def offset : Int32 #

Returns the offset from UTC in seconds.